  include "tios.h"
  include "util.h"
  
  
  xdef  _main
  xdef  _ti89

WriteStr  MACRO ; prints a string
          move.w \3,-(a7)
          pea \4
          move.w \2,-(a7)
          move.w \1,-(a7)
          jsr tios::DrawStrXY
          add    #10,a7 
          ENDM

WriteChar  MACRO ; prints a character
          move.w \1,-(a7)
          move.w \2,-(a7)
          move.w \3,-(a7)
          move.w \4,-(a7)
          jsr    util::DrawCharXY
          add    #8,a7
          ENDM
 
_main:


intro: ; small scrolling
 WriteStr   #185,#40,#4,intro_string ; text which will be scrolled
 move.w     #40,d6 ; counter ( 41 cycles )
 move.l     #90000,d5 ; wait counter

intro_start:
 move.l     #tios::main_lcd,a0 ; actual screen
 move.l     #tios::main_lcd+2,a1
 move.w     #1904,d0 ; counter (copy the whole screen)

intro_start_loop: ; shift the screen left ( 16 pix )
 move.w     (a1)+,(a0)+
 dbra       d0,intro_start_loop
 clr.w      d3

intro_wait:
 tst        tios::kb_vars+$1c
 bne        init_game ; you can stop the scrolling
 add        #1,d3
 cmp        d3,d5
 bne        intro_wait ; pause
 dbra       d6,intro_start
 ;end


init_game: ; set the vars + credits

 ; credits

 move.w   #2,-(a7) ; big font
 jsr      tios::FontSetSys
 add.w    #2,a7
 jsr      util::zap_screen
 WriteStr #45,#25,#4,intro0 ; "ultraplane"
 WriteStr #45,#55,#4,intro1 ; "by gandalf"
 jsr      util::idle_loop
 cmp      #264,d0 ; esc
 bne      init_game
 jsr      util::zap_screen
 move.w   #1,-(a7) ; normal font
 jsr      tios::FontSetSys
 add.w    #2,a7

 ; vars set

 move.w   #1,skill ; default difficulty
 clr.w   d4
 move.w  #2528,player ;30*84+8 = player's coord
 clr.w   score ; le score
 move.w	#1023,d0 ;1023 = 111111111 : 10 possible cases => 10 bts
 jsr	util::random
 move.w	d0,wall1_var ; 1 bit set  = 1 mur
 clr.w	wall1_coord
 move.w	#1023,d0
 jsr	util::random
 move.w	d0,wall2_var ; same thing for the second line
 clr.w   wall2_coord
 clr.w   Time ; time counter
 move.w  #9,d2 ; for the pixel test : the top of the screen is a the 8th bit

menu:
 jsr         util::zap_screen
 move.w      #30*10,coord_cursor ; cursor coord
 clr.w       coord_cursor_temp
 WriteStr    #20,#10,#4,start_game ; "play"
 WriteStr    #20,#30,#4,menu1 ; "thanks"
 WriteStr    #20,#50,#4,menu2 ; "How to play?"
 WriteStr    #20,#70,#4,menu3 ; "difficulty"
 WriteStr    #20,#90,#4,menu4 ; "Quit"
 bsr         cursor_draw

menu_wait: ; moving in the menu
 tst         tios::kb_vars+$1c
 beq         menu_wait
 move.w      tios::kb_vars+$1e,d0
 clr.w       tios::kb_vars+$1c
 clr.w       tios::kb_vars+$1e
 cmp         #340,d0 ; up
 beq         cursor_up
 cmp         #337,d0 ; down
 beq         cursor_down
 cmp         #264,d0 ; esc
 beq         exit2
 cmp         #13,d0 ; enter
 beq         choose_ok
 bra         menu_wait

cursor_up:
 cmp         #30*90,coord_cursor ; max
 beq         menu_wait
 move.w      #30*20,coord_cursor_temp ; updating cursor position var
 bra         cursor_erase

cursor_down:
 cmp         #30*10,coord_cursor ; min
 beq         menu_wait
 move.w      #-30*20,coord_cursor_temp ; updating cursor position var

cursor_erase:
 move.l      #tios::main_lcd,a0
 add         coord_cursor,a0
 move.w      #6,d3 ;counter (7 lines)

cursor_erase_loop:
 clr.w       (a0)
 add         #30,a0
 dbra        d3,cursor_erase_loop
 bsr         cursor_draw
 bra         menu_wait

cursor_draw:
 move.w      coord_cursor_temp,d4
 add         d4,coord_cursor ; update cursor coord
 move.l      #tios::main_lcd,a0
 add         coord_cursor,a0
 move.w      #6,d3 ;counter (7 lines)
 lea         cursor(pc),a3

cursor_draw_loop:
 move.w      (a3)+,(a0)
 add         #30,a0
 dbra        d3,cursor_draw_loop
 rts

choose_ok: ; which menu have you chosen
 cmp         #30*10,coord_cursor ; play
 beq         play
 cmp         #30*30,coord_cursor ; thanks
 beq         thanks
 cmp         #30*50,coord_cursor ; how to play
 beq         how_to_play
 cmp         #30*70,coord_cursor ;difficulty
 beq         difficulty
 cmp         #30*90,coord_cursor ; quit
 beq         exit2

thanks:
 jsr      util::zap_screen
 move.w   #0,-(a7) ; small font
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #0,#15,#4,laurent
 WriteStr #0,#30,#4,michou
 WriteStr #0,#45,#4,jah
 jsr      util::idle_loop
 move.w   #1,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 bra      menu

how_to_play:
 jsr      util::zap_screen
 move.w   #0,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #0,#0,#4,rules
 WriteStr #0,#35,#4,rules2
 WriteStr #0,#50,#4,rules3 
 jsr      util::idle_loop
 move.w   #1,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 bra      menu

difficulty: ; rglage de la difficult
 jsr       util::zap_screen
 WriteStr  #20,#20,#4,ask_skill
 move.w    skill,d7
 add       #48,d7 ; turn the difficulty level into his ASCII value
 WriteChar #4,#40,#50,d7 ; prints the difficulty level
 sub       #48,d7 ; back to the difficulty level
 jsr       util::idle_loop
 cmp       #337,d0 ; up
 beq       difficulty_up
 cmp       #340,d0 ; down
 beq       difficulty_down
 cmp       #13,d0 ; enter
 beq       menu
 bra       difficulty

difficulty_up:
 cmp       #3,skill ; max
 beq       difficulty
 add       #1,skill
 bra       difficulty

difficulty_down:
 cmp       #1,skill ; min
 beq       difficulty
 sub       #1,skill
 bra       difficulty

play:
 jsr       util::zap_screen
 clr.w     d4

Install_Timer:
 move.l  $64+(5-1)*4,oldTimer ; save old interrupt routine
 bclr.b  #2,($600001) ; disable auto-int 7
 move.l  #TimerInterrupt,$64+(5-1)*4 ; install the interrupt routine
 bset.b  #2,($600001) ; enable auto-int 7
 move.b  #$D1,frequence_counter; set the timer frequence var
 move.b  #$D1,($600017) ; put default frequence

set_walls:; wall drawing routine ( parameters : first line , then second line )
 move.w wall1_coord,d6; 1st parameter
 move.w wall1_var,d0;   
 bsr    teste_bit_init
 cmp    #15*3,score ;draw second line when the first one has reached the middle of the screen
 blt    player_draw
 move.w wall2_coord,d6; 2nd parameter
 move.w wall2_var,d0;    
 bsr    teste_bit_init
 bra	player_draw

teste_bit_init:
 clr.w  d7 ; reset case pointer
 clr.w  d3

teste_bit:
 btst.b d3,d0 ; check if there is a wall
 beq    next_bit ; set = wall at this case , else next bit

draw_wall:
 move.l #tios::main_lcd,a0
 add    d6,a0 ; set the screen
 add    d7,a0 ; update case position counter
 move.w #15,d5 ; counter (16 lines)

draw_wall_loop:
 move.w #$ffff,(a0)
 add    #30,a0
 dbra   d5,draw_wall_loop ;16*16 square

next_bit: ; next case
 add    #1,d3 ; update bit pointer
 add    #2,d7 ; update case pointer
 cmp    #20,d7 ; 10 case
 bne    teste_bit ; finished => draw ship , else do it again
 rts


walls_clear_set  ; same as set walls but clears the line
 move.w wall1_coord,d6
 bsr    wall_clear_init
 move.w d5,-(a7) ; next line
 clr.l  d5 
 move.w #30,d5
 mulu   skill,d5 ; scroll the walls of the difficulty level ( ex : lvl 2 = 2 pix )
 add    d5,wall1_coord
 move.w (a7)+,d5
 cmp    #15*3,score
 blt    next_line
 move.w wall2_coord,d6
 bsr    wall_clear_init
 move.w d5,-(a7) ; next line
 clr.l  d5
 move.w #30,d5
 mulu   skill,d5
 add    d5,wall2_coord
 move.w (a7)+,d5
 bra    next_line

wall_clear_init:
 clr.w  Time
 clr.w  d7

wall_clear:
 move.l #tios::main_lcd,a0
 add    d6,a0
 add    d7,a0
 move.w #15,d5 ; counter (16 lines)

wall_clear_loop:
 clr.w  (a0)
 add    #30,a0
 dbra   d5,wall_clear_loop
 add    #2,d7
 cmp    #20,d7
 bne    wall_clear
 rts

next_line:
 move.w skill,d7
 add    d7,score
 clr.w  d3 ; reset pointer
 clr.w  d7 ;  reset pointer
 cmp    #15*30*6,wall1_coord ; reached the bottom ?
 bhi    new_deal1 ; if yes , new line
 cmp    #15*30*6,wall2_coord
 bhi    new_deal2
 bra    set_walls

wait:
 cmp     #2,Time ;wait a bit before printing a new line
 bgt     walls_clear_set
 tst.w   tios::kb_vars+$1c
 beq     wait
 move.w  tios::kb_vars+$1e,d0; pressed key getkey
 clr.w   tios::kb_vars+$1c ;reset buffers
 clr.w   tios::kb_vars+$1e ;
 cmp     #264,d0 ;esc
 beq     menu_return
 cmp     #344,d0; right
 bne     no_droite
 cmp    #2538,player ; 30*84+18 (max)
 beq    wait
 move.w #2,d4 ; moving var

no_droite:
 cmp     #338,d0; left
 bne     no_gauche
 cmp    #2520,player ; 30*84 (min)
 beq    wait
 move.w #-2,d4

no_gauche:
 cmp     #263,d0; clear
 bne     no_shut
 trap    #4

no_shut:
 bra     erase_player

menu_return:
 bsr     exit
 bra     init_game

erase_player:
 move.l #tios::main_lcd,a0
 add    player,a0 ;
 clr.w  d5
 move.b #15,d5 ; 16 wide

erase_player_loop:
 clr.w  (a0)
 lea    30(a0),a0
 dbra   d5,erase_player_loop

player_draw:
 add    d4,player ; update player's coord
 move.l #tios::main_lcd,a0
 lea    player_sprite(pc),a3
 add    player,a0 ; new coords
 btst.b #8,-30(a0); test if there is a pix in front of you
 bne    game_over ;if there is one , you've loosed
 add    #30,a0 ; else restore the screen
 clr.w  d5
 move.b #14,d5; counter (15 lines)

player_draw_loop:
 move.w (a3)+,(a0)
 lea    30(a0),a0
 dbra   d5,player_draw_loop
 clr.w  d4 ; reset moving var
 bra    wait

TimerInterrupt:
 add.w   #1,Time ; update time counter
 move.l  oldTimer,-(a7)
 rts

new_deal1: ; new "line1"
 clr.w   d0
 move.w  #1023,d0
 jsr     util::random; new number
 move.w  d0,wall1_var
 clr.w   wall1_coord ; reset wall1's coord
 bra     set_walls

new_deal2: ; new "line2"
 clr.w   d0
 move.w  #1023,d0
 jsr     util::random
 move.w  d0,wall2_var
 clr.w   wall2_coord
 move.b	 frequence_counter,($600017) ; increase the timer frequence
 add.b	 #1,frequence_counter ; increase the timer frequence counter
 bra     set_walls

game_over:
 move.w   #2,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #40,#20,#4,end1
 jsr      util::idle_loop

exit:
 jsr      util::zap_screen
 move.w   score,-(a7)
 pea      format ; decimal
 pea      buffer ; string where the score will be pushed
 jsr      _ROM_CALL_53 ; push the score in the string
 add      #10,a7
 move.w   #2,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #10,#40,#4,points ; "your score" and print your score (no ",0")
 jsr      util::idle_loop
 cmp      #13,d0 ; enter
 bne      exit

uninstall-timer:
 bclr.b   #2,($600001) ; disable auto-int 7
 move.l   oldTimer,$64+(5-1)*4 ;uninstall the interrupt routine
 bset.b   #2,($600001) ; enable auto-int 7
 move.b   #$B1,($600017); restore default timer frequence

exit2:
 jsr      util::zap_screen
 move.w   #0,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #0,#15,#4,contact ; "If u notice any bug or if u have any"
 WriteStr #0,#25,#4,contact1 ; "questions or comments , please mail me at:"
 WriteStr #0,#35,#4,contact2 ; "Ric.Daubry@wanadoo.fr"
 jsr      util::idle_loop
 rts

 ;SPRITE DECLARATION

cursor       dc.w  %10000000
	     dc.w  %11100000
	     dc.w  %11111100
	     dc.w  %11111111
	     dc.w  %11111100
	     dc.w  %11110000
	     dc.w  %10000000

player_sprite:
 dc.w %0000000110000000
 dc.w %0000000110000000
 dc.w %0000000110000000
 dc.w %0000001111000000
 dc.w %0000001001000000
 dc.w %0000001001000000
 dc.w %0000001111000000
 dc.w %0010011111100100
 dc.w %0010101111010100
 dc.w %0011001111001100
 dc.w %0100001111000010
 dc.w %1000001111000001
 dc.w %1111111111111111
 dc.w %0001110000111000
 dc.w %0000100000010000

 ;VAR DECLARATION

coord_cursor dc.w  0
coord_cursor_temp dc.w  0
player         dc.w 0
score          dc.w 0
wall1_coord    dc.w 0
wall1_var      dc.w 0
wall2_coord    dc.w 0
wall2_var      dc.w 0
oldTimer       dc.l 0
Time           dc.w 0
skill          dc.w 0
frequence_counter dc.w $D1

 ;STRING DECLARATION

intro_string   dc.b "ready ?",0
intro0    dc.b  "ULTRAPLANE",0
intro1    dc.b  "by gandalf",0
end1      dc.b  "GAME OVER",0
start_game dc.b  "Play",0
menu1     dc.b  "Thanks",0
menu2     dc.b  "How to play?",0
menu3     dc.b  "difficulty",0
menu4     dc.b  "Quit",0
laurent   dc.b  ".Spike : sprites making",0
michou    dc.b  ".Angelo : tests and advices",0
jah       dc.b  ".Jah (of course)",0
rules     dc.b  "Move with left and right button to avoid walls",0
rules2    dc.b  "You can exit the game with esc and shut down",0
rules3    dc.b  "the calc with clear",0
ask_skill dc.b  "difficulty level ?",0
contact   dc.b  "If u notice any bug or if u have any",0
contact1  dc.b  "questions or comments , please mail me at:",0
contact2  dc.b  "Ric.Daubry@wanadoo.fr",0
format    dc.b  "%d",0
points    dc.b  "your score:"
buffer    ds.b  7

  end